"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cryptography = __importStar(require("@liskhq/lisk-cryptography"));
const get_transaction_id_1 = require("./get_transaction_id");
const sign_and_verify_1 = require("./sign_and_verify");
const time_1 = require("./time");
const secondSignTransaction = (transactionObject, secondPassphrase) => (Object.assign({}, transactionObject, { signSignature: sign_and_verify_1.signTransaction(transactionObject, secondPassphrase) }));
const validTransaction = (partial) => partial.type !== undefined;
exports.prepareTransaction = (partialTransaction, passphrase, secondPassphrase, timeOffset) => {
    const senderPublicKey = passphrase
        ? cryptography.getKeys(passphrase).publicKey
        : undefined;
    const timestamp = time_1.getTimeWithOffset(timeOffset);
    const transaction = Object.assign({ amount: '0', recipientId: '', senderPublicKey,
        timestamp }, partialTransaction);
    if (!validTransaction(transaction)) {
        throw new Error('Invalid transaction to process');
    }
    if (!passphrase) {
        return transaction;
    }
    const singleSignedTransaction = Object.assign({}, transaction, { signature: sign_and_verify_1.signTransaction(transaction, passphrase) });
    const signedTransaction = typeof secondPassphrase === 'string' && transaction.type !== 1
        ? secondSignTransaction(singleSignedTransaction, secondPassphrase)
        : singleSignedTransaction;
    const transactionWithId = Object.assign({}, signedTransaction, { id: get_transaction_id_1.getTransactionId(signedTransaction) });
    return transactionWithId;
};
//# sourceMappingURL=prepare_transaction.js.map